<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDb" %>
<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Drawing.Imaging" %>
<script language="C#" runat="server">

  void CreatePieChart(String tableName, String dataColumnName, String labelColumnName, String title, 
			int width)
  {
	// We need to connect to the database and grab information for the
	// particular columns for the particular table

	// 1. Create a connection
	const String connString = "Provider=Microsoft.Jet.OLEDB.4.0;" + 
                             "Data Source=C:\\My Projects\\ASP.NET Teaching\\UCSD Teaching\\Code\\GrocerToGo.mdb";
	OleDbConnection myConnection = new OleDbConnection(connString);
	myConnection.Open();

	// 2. Create a command object for the query
	String sql = "SELECT [" + dataColumnName + "], [" + labelColumnName + "] FROM " + tableName;
	OleDbCommand myCommand = new OleDbCommand(sql, myConnection);

	// 3. Create/Populate the DataSet
	DataSet ds = new DataSet();
	OleDbDataAdapter myAdapter = new OleDbDataAdapter(myCommand);
	myAdapter.Fill(ds);

	// close the connection
	myConnection.Close();

	// find the total of the numeric data
	float total = 0.0F, tmp;
	int iLoop;
	for (iLoop=0; iLoop < ds.Tables[0].Rows.Count; iLoop++)
	{
		tmp = Convert.ToSingle(ds.Tables[0].Rows[iLoop][dataColumnName]);
		total += tmp;
	}


	// we need to create fonts for our legend and title
	Font fontLegend = new Font("Verdana", 10),
		fontTitle = new Font("Verdana", 15, FontStyle.Bold);

	// We need to create a legend and title, how big do these need to be?
	// Also, we need to resize the height for the pie chart, respective to the
	// height of the legend and title
	const int bufferSpace = 15;
	int legendHeight = fontLegend.Height * (ds.Tables[0].Rows.Count+1) + bufferSpace;
	int titleHeight = fontTitle.Height + bufferSpace;
	int height = width + legendHeight + titleHeight + bufferSpace;
	int pieHeight = width;	// maintain a one-to-one ratio

	// Create a rectange for drawing our pie
	Rectangle pieRect = new Rectangle(0, titleHeight, width, pieHeight);

	// Create our pie chart, start by creating an ArrayList of colors
	ArrayList colors = new ArrayList();
	Random rnd = new Random();
	for (iLoop = 0; iLoop < ds.Tables[0].Rows.Count; iLoop++)
		colors.Add(new SolidBrush(Color.FromArgb(rnd.Next(255), rnd.Next(255), rnd.Next(255))));
	
	float currentDegree = 0.0F;

	// Create a Bitmap instance	
	Bitmap objBitmap = new Bitmap(width, height);
	Graphics objGraphics = Graphics.FromImage(objBitmap);

	SolidBrush blackBrush = new SolidBrush(Color.Black);

	// Put a white backround in
	objGraphics.FillRectangle(new SolidBrush(Color.White), 0, 0, width, height);
	for (iLoop = 0; iLoop < ds.Tables[0].Rows.Count; iLoop++)
	{
		objGraphics.FillPie((SolidBrush) colors[iLoop], pieRect, currentDegree,
				Convert.ToSingle(ds.Tables[0].Rows[iLoop][dataColumnName]) / total * 360);

		// increment the currentDegree
		currentDegree += Convert.ToSingle(ds.Tables[0].Rows[iLoop][dataColumnName]) / total * 360;
	}

	// Create the title, centered
	StringFormat stringFormat = new StringFormat();
	stringFormat.Alignment = StringAlignment.Center;
	stringFormat.LineAlignment = StringAlignment.Center;

	objGraphics.DrawString(title, fontTitle, blackBrush, 
				 new Rectangle(0, 0, width, titleHeight), stringFormat);


	// Create the legend
	objGraphics.DrawRectangle(new Pen(Color.Black, 2), 0, height - legendHeight, width, legendHeight);
	for (iLoop = 0; iLoop < ds.Tables[0].Rows.Count; iLoop++)
	{
		objGraphics.FillRectangle((SolidBrush) colors[iLoop], 5, 
			height - legendHeight + fontLegend.Height * iLoop + 5, 10, 10);
		objGraphics.DrawString(((String) ds.Tables[0].Rows[iLoop][labelColumnName]) + " - " + 
				 Convert.ToString(ds.Tables[0].Rows[iLoop][dataColumnName]), fontLegend, blackBrush, 
				 20, height - legendHeight + fontLegend.Height * iLoop + 1);
	}

	// display the total
	objGraphics.DrawString("Total: " + Convert.ToString(total), fontLegend, blackBrush, 
			 5, height - fontLegend.Height - 5);

	// Since we are outputting a Jpeg, set the ContentType appropriately
	Response.ContentType = "image/jpeg";

	// Save the image to a file
	objBitmap.Save(Response.OutputStream, ImageFormat.Jpeg);

	// clean up...
	objGraphics.Dispose();
	objBitmap.Dispose();
  }


  void Page_Load(Object sender, EventArgs e)
  {
     CreatePieChart("Products", "UnitPrice", "ProductName", "Price Breakdown", 300);
  }
</script>